/*
 * Copyright (C) 2019-2023 EXOLIGENT (www.exoligent.com)
 * Author: Maxime Coroyer <maxime.coroyer@exoligent.com>
 */

#ifndef __FW_PCI_H__
#define __FW_PCI_H__

#include <linux/kernel.h>
#include "fw-drv.h"

void wait_for_us(uint32_t delay_us);
int wait_for_reg32(uint32_t *reg, uint32_t flags, uint32_t timeout_us,
    uint8_t trigger_level);

void eeprom_enable(struct fw_dev *fw);
void eeprom_disable(struct fw_dev *fw);
void eeprom_do_clock_cycle(struct fw_dev *fw);
void eeprom_write_data_bit_high(struct fw_dev *fw);
void eeprom_write_data_bit_low(struct fw_dev *fw);
uint8_t eeprom_read_data_bit(struct fw_dev *fw);
uint8_t eeprom_read_data_bit_no_clock(struct fw_dev *fw);
uint8_t eeprom_read(struct fw_dev *fw, uint8_t *buffer, uint8_t start_address,
    uint8_t length);

void init_interrupt(struct fw_dev *fw);

int fw_irq_global_enable(struct fw_dev *fw, int enable);
int fw_irq_global_clear(struct fw_dev *fw, int clear);
int fw_board_init(struct fw_dev *fw);
int fw_reset(struct fw_dev *fw, void __user *uarg);

#endif 
